%define product Red Hat OpenStack Platform director
%define product_short RHOSPd
%define product_code OSPd
%define ospd_build 20230412.1
%define base_name rhosp-director-images
%define rhel_version 8.3
%define rhosp_release_ver 16.2.0-1

%global with_ppc64le 1
%global with_amphora 1
%global old_school 0

Summary: %{product} Images
Name: rhosp-director-images
Version: 16.2
Release: %{ospd_build}%{?dist}%{?extra_release}

%if 0%{?old_school}
Source1: overcloud-full-%{version}-%{ospd_build}.x86_64.tar
Source2: ironic-python-agent-%{version}-%{ospd_build}.x86_64.tar
%if 0%{?with_amphora}
Source3: octavia-amphora-%{version}-%{ospd_build}.x86_64.tar
# with_amphora
%endif
%if 0%{?with_ppc64le}
Source4: overcloud-full-%{version}-%{ospd_build}.ppc64le.tar
Source5: ironic-python-agent-%{version}-%{ospd_build}.ppc64le.tar
# with_ppc64le
%endif
Source8: overcloud-minimal-%{version}-%{ospd_build}.x86_64.tar
%endif

BuildArch: noarch

License: AFL and BSD and (BSD or GPLv2+) and BSD with advertising and Boost and GFDL and GPL and GPL+ and (GPL+ or Artistic) and GPLv1+ and GPLv2 and (GPLv2 or BSD) and (GPLv2 or GPLv3) and GPLv2 with exceptions and GPLv2+ and (GPLv2+ or AFL) and GPLv2+ with exceptions and GPLv3 and GPLv3+ and GPLv3+ with exceptions and IJG and ISC and LGPLv2 and LGPLv2+ and (LGPLv2+ or BSD) and (LGPLv2+ or MIT) and LGPLv2+ with exceptions and LGPLv2/GPLv2 and LGPLv3 and LGPLv3+ and MIT and (MIT or LGPLv2+ or BSD) and (MPLv1.1 or GPLv2+ or LGPLv2+) and Open Publication and OpenLDAP and OpenSSL and Public Domain and Python and (Python or ZPLv2.0) and Rdisc and Redistributable, no modification permitted and SISSL and Vim and zlib
Group: Applications/System
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot
URL: http://rdoproject.org/

Requires: rhosp-director-images-x86_64 = %{version}-%{release}
Provides: installonlypkg(vm)

%define app_root %{_datadir}/%{base_name}
%define octavia_root %{_datadir}/openstack-octavia-amphora-images

#  disable debuginfo, makes no sense for boot image and it is created empty anyway
%define debug_package %{nil}

%description
The overcloud images for %{product}

%package all
Requires: rhosp-director-images-x86_64 = %{version}-%{release}
Requires: rhosp-director-images-ipa-x86_64 = %{version}-%{release}
%if 0%{?with_amphora}
Requires: octavia-amphora-image-x86_64 = %{version}-%{release}
# with_amphora
%endif
%if 0%{?with_ppc64le}
Requires: rhosp-director-images-ppc64le = %{version}-%{release}
Requires: rhosp-director-images-ipa-ppc64le = %{version}-%{release}
# with_ppc64le
%endif
Requires: rhosp-director-images-minimal = %{version}-%{release}
Summary:  Meta package for overcloud/Ironic images for all architectures

%description all
The overcloud image deployed for %{product}

%if 0%{?old_school}
%package x86_64
Requires: rhosp-director-images-ipa-x86_64 = %{version}-%{release}
Provides: installonlypkg(vm)
Summary:  x86_64 Overcloud images
Requires(posttrans): rhosp-release > %{rhosp_release_ver}
Requires(preun): rhosp-release > %{rhosp_release_ver}
%if 0%{?with_amphora}
Requires: octavia-amphora-image-x86_64 = %{version}-%{release}
# with_amphora
%endif

%description x86_64
The overcloud x86_64 image deployed for %{product}

# old_school
%endif

%package ipa
Provides: installonlypkg(vm)
Summary:  x86_64 Ironic Python Agent Images
Requires: %{name} = %{version}-%{release}

%description ipa
The x86_64 ramdisk and kernel images used to introspect and deploy overcloud
images for %{product}

%if 0%{?old_school}
%package ipa-x86_64
Provides: installonlypkg(vm)
Summary:  x86_64 Ironic Python Agent Images
Requires(posttrans): rhosp-release > %{rhosp_release_ver}
Requires(preun): rhosp-release > %{rhosp_release_ver}

%description ipa-x86_64
The x86_64 ramdisk and kernel images used to introspect and deploy overcloud
images for %{product}

%if 0%{?with_ppc64le}
%package ppc64le
Requires: rhosp-director-images-ipa-ppc64le = %{version}-%{release}
Provides: installonlypkg(vm)
Summary:  ppc64le Overcloud images
Requires(posttrans): rhosp-release > %{rhosp_release_ver}
Requires(preun): rhosp-release > %{rhosp_release_ver}

%if 0%{?with_amphora}
# odd to add x86_64 here, but ensuring that for an all-ppc64le overcloud
# the octavia image is available.  This likely gets replaced with
# a ppc64le version when it's avaialble
Requires: octavia-amphora-image-x86_64 = %{version}-%{release}
# with_amphora (inside ppc64le)
%endif

%description ppc64le
The overcloud ppc64le image deployed for %{product}

%package ipa-ppc64le
Provides: installonlypkg(vm)
Summary:  ppc64le Ironic Python Agent Images
Requires(posttrans): rhosp-release > %{rhosp_release_ver}
Requires(preun): rhosp-release > %{rhosp_release_ver}

%description ipa-ppc64le
The ppc64le ramdisk and kernel images used to introspect and deploy overcloud
images for %{product}
# with_ppc64le
%endif

%if 0%{?with_amphora}
%package -n octavia-amphora-image-x86_64
Provides: octavia-amphora-image = %{version}-%{release}
Obsoletes: octavia-amphora-image < 13.0-20180711.1
Provides: installonlypkg(vm)
Summary:  Octavia Amphora image
Requires(posttrans): rhosp-release > %{rhosp_release_ver}
Requires(preun): rhosp-release > %{rhosp_release_ver}

%description -n octavia-amphora-image-x86_64
The Octavia Amphora image for %{product}
%endif

%package minimal
Provides: installonlypkg(vm)
Summary: director minimal image
Requires(posttrans): rhosp-release > %{rhosp_release_ver}
Requires(preun): rhosp-release > %{rhosp_release_ver}

%description minimal
The director minimal x86_64 image deployed for %{product}

%else

%package metadata
Summary: Metadata for rhosp-director-images
Provides: installonlypkg(vm)
Requires(posttrans): rhosp-release >= %{rhosp_release_ver}
Requires(preun): rhosp-release >= %{rhosp_release_ver}
Requires: %{name}-base

%description metadata
This contains version information and additional requirements for
rhosp-director-images.

%package base
Summary: Root directories for OpenStack images

%description base
This contains the root directories for Red Hat OpenStack Platform
images.

# old_school
%endif

%prep

%build

%install
%{__rm} -rf %{buildroot}
mkdir %{buildroot}

%{__install} -d -m0755 %{buildroot}%{app_root}
%if 0%{?old_school}
%{__install} -p -m0644 %{SOURCE1} %{buildroot}%{app_root}/overcloud-full-%{version}-%{release}.x86_64.tar
%{__install} -p -m0644 %{SOURCE2} %{buildroot}%{app_root}/ironic-python-agent-%{version}-%{release}.x86_64.tar
%if 0%{?with_ppc64le}
%{__install} -p -m0644 %{SOURCE4} %{buildroot}%{app_root}/overcloud-full-%{version}-%{release}.ppc64le.tar
%{__install} -p -m0644 %{SOURCE5} %{buildroot}%{app_root}/ironic-python-agent-%{version}-%{release}.ppc64le.tar
# with_ppc64le
%endif
%{__install} -p -m0644 %{SOURCE8} %{buildroot}%{app_root}/overcloud-minimal-%{version}-%{release}.x86_64.tar
# old_school
%endif
echo %{version},%{release} > %{buildroot}%{app_root}/version-%{version}-%{release}.txt

%if 0%{?with_amphora}
%{__install} -d -m0755 %{buildroot}%{octavia_root}
%if 0%{?old_school}
tar xf %{SOURCE3} -C %{buildroot}%{octavia_root}
# old_school
%endif
echo %{version},%{release} > %{buildroot}%{octavia_root}/version-%{version}-%{release}.txt
# with_amphora
%endif

%if 0%{?old_school}
%if 0%{?with_ppc64le}
%posttrans ppc64le
%{_sbindir}/rhosp-director-image-update ||:
# with_ppc64le
%endif

%posttrans x86_64
%{_sbindir}/rhosp-director-image-update ||:

%posttrans ipa-x86_64
%{_sbindir}/rhosp-director-image-update ||:

%if 0%{?with_ppc64le}
%posttrans ipa-ppc64le
%{_sbindir}/rhosp-director-image-update ||:
# with_ppc64le
%endif

%if 0%{?with_amphora}
%posttrans -n octavia-amphora-image-x86_64
%{_sbindir}/rhosp-director-image-update ||:
# with_amphora
%endif

%posttrans minimal
%{_sbindir}/rhosp-director-image-update ||:

%preun x86_64
%{_sbindir}/rhosp-director-image-update --rm %{version}-%{ospd_build} ||:

%if 0%{?with_ppc64le}
%preun ppc64le
%{_sbindir}/rhosp-director-image-update --rm %{version}-%{ospd_build} ||:
# with_ppc64le
%endif

%preun ipa-x86_64
%{_sbindir}/rhosp-director-image-update --rm %{version}-%{ospd_build} ||:

%if 0%{?with_ppc64le}
%preun ipa-ppc64le
%{_sbindir}/rhosp-director-image-update --rm %{version}-%{ospd_build} ||:
# with_ppc64le
%endif

%if 0%{?with_amphora}
%preun -n octavia-amphora-image-x86_64
%{_sbindir}/rhosp-director-image-update --rm %{version}-%{ospd_build} ||:
# with_amphora
%endif

%preun minimal
%{_sbindir}/rhosp-director-image-update --rm %{version}-%{ospd_build} ||:

# old_school
%endif

%clean
%{__rm} -rf %{buildroot}

%files
%defattr(0644,root,root,0755)

%files all

%if 0%{?old_school}
%files x86_64
%{app_root}/overcloud-full*x86_64*
# This is slightly broken as we only maintain the version file in the x86_64 package
%{app_root}/version*

%files ipa

%files ipa-x86_64
%{app_root}/ironic-python-agent*x86_64*
%{app_root}/version*

%if 0%{?with_amphora}
%files -n octavia-amphora-image-x86_64
%{octavia_root}/octavia-amphora*
%{octavia_root}/version*
%endif

%if 0%{?with_ppc64le}
%files ppc64le
%{app_root}/overcloud-full*ppc64le.*
%{app_root}/version*

%files ipa-ppc64le
%{app_root}/ironic-python-agent*ppc64le.*
%{app_root}/version*
# ppc64le
%endif

%files minimal
%{app_root}/overcloud-minimal*x86_64*
%{app_root}/version*

# old_school
%else

%files metadata
%{app_root}/version*
%{octavia_root}/version*

%files base
%dir %{app_root}
%dir %{octavia_root}

# old_school
%endif

%changelog
* Wed Apr 05 2023 Thierry Vignaud <tvignaud@redhat.com> 16.2-20230405.2
- OSP 16.2.5 RHEL 8.4 based images

* Wed Apr 27 2022 Thierry Vignaud <tvignaud@redhat.com> 16.2-20220427.1
- OSP 16.2.3 RHEL 8.4 based images

* Wed Feb 09 2022 Miguel Garcia <mgarciac@redhat.com> - 16.2-20220209.1
- OSP 16.2.2 RHEL 8.4 based images

* Wed Oct 06 2021 Thierry Vignaud <tvignaud@redhat.com> 16.2-20211006.1
- OSP 16.2.1 RHEL 8.4 based images

* Wed Jul 22 2020 Thierry Vignaud <tvignaud@redhat.com> 16.1-20200722.1
- OSP 16.1 RHEL 8.2 based images

* Fri Mar 06 2020 Thierry Vignaud <tvignaud@redhat.com> 16.0-20200306.1
- Remove HA packages from overcloud-minimal (rhbz#1802312)

* Tue Feb 05 2019 Thierry Vignaud <tvignaud@redhat.com> 14.0-20190205.1
- respin OSP 14 image

* Wed Jan 16 2019 Thierry Vignaud <tvignaud@redhat.com> 14.0-20190116.2
- respin OSP 14 image

* Thu Dec 20 2018 Thierry Vignaud <tvignaud@redhat.com> 14.0-20181220.1
- OSP 14 RHEL 7.6 based images
- Add Multi-arch director images
- convert to using preun and posttrans script handling from rhosp-release
- move octavia images to /usr/share/openstack-octavia-amphora-images (rhbz#1645572)
- ensure that octavia is always installed (rhbz#1644688)

* Tue Mar 13 2018 Alex Schultz <aschultz@redhat.com> 13.0-20180302.1
- Run virt-sysprep on images (rhbz#1551603)

* Fri Feb 02 2018 Jason Joyce <jjoyce@redhat.com> 13.0-20180202.3
- OSP 13 RHEL 7.5 based images

* Tue Dec 05 2017 Jon Schlueter <jschluet@redhat.com> 13.0-20171205.1
- OSP 13 initial images
